const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const warehouses = sequelize.define(
    'warehouses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  warehouses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.warehouses.hasMany(db.storage_locations, {
      as: 'storage_locations_warehouse',
      foreignKey: {
          name: 'warehouseId',
      },
      constraints: false,
    });





















//end loop






    db.warehouses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.warehouses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return warehouses;
};


